SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/23/2012 19:11'!
initialize
  "manda un mensaje a su superclase"
  super initialize.
  "No ponemos ninguna etiqueta"
  self label: ''.
  "Ajustamos el tamanho del borde de la celda"
  self borderWidth: 2. 
  "Borde de la Figura , formamos un cuadrado"
   "Cada celda tiene 20 de ancho x 20 de alto"
  bounds:= 0@0 corner:20@20.
  "Que tal si le ponemos azul, para cuando este desactivado"
  offColor:= Color lightBlue .
  "y cuando esta activo?"
  onColor:= Color lightGray .
  "Se puede cambiar la forma de las esquinas de "
  "cuadradas por redondeadas"
  "self useRoundedCorners."
  self useSquareCorners. "Usamos esquinas de forma cuadrada"
  self turnOff
! !

!LOCell methodsFor: 'accessing' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:21'!
mouseAction 
^mouseAction ! !

!LOCell methodsFor: 'accessing' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:14'!
mouseAction: aBlock
^mouseAction := aBlock! !

!LOCell methodsFor: 'event handling' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:23'!
mouseUp: anEvent
mouseAction value! !

DockingBarMorph subclass: #LOToolbar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOToolbar methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/27/2012 14:08'!
initialize 
   "Declaracin de variables locales"
  | CloseB HelpB| 
  super initialize . "Manda un mensaje a la super clase"

  CloseB  := SimpleButtonMorph new.
  CloseB   label: 'Cerrar'.
  CloseB color: Color lightBlue .
  CloseB borderColor: Color lightBlue .
  CloseB  target: [LOGame  allInstances last delete].
  CloseB actionSelector: #value.
 
  HelpB := SimpleButtonMorph new.
  HelpB label: 'Ayuda'.
  HelpB color: Color lightBlue .
  HelpB borderColor: Color lightBlue .
  HelpB target: [UIManager inform: 'Integrantes: Roxana Limachi , Nury Arosquipa'].
  HelpB actionSelector: #value.
  
  self height: CloseB height .
   self addMorph: HelpB .
   self addMorph: CloseB.

  
  
   
    ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/23/2012 17:55'!
cellsPerSide 
  "El nmero de celdas en ancho y alto del juego Ej. 20 de ancho por 20 de alto"
  ^20! !

!LOGame methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/27/2012 13:46'!
initialize 
   "Declaracin de variables locales"
   | sampleCell width height  n toolbar|
   super initialize . "Manda un mensaje a la super clase"
   "Self se refiere al receptor del mtodo de ejecucin actual"
    n:= self cellsPerSide. "Self es una pseudo-variable"
   sampleCell  := LOCell  new. "sampleCell es un objeto de la clase LoCell"
   toolbar := LOToolbar new. 
   width := sampleCell width. "ancho de cada celda"
   height := sampleCell height. "alto de cada celda"
   self bounds: (0@0 extent: ((width*n)@(height*n+toolbar height ))+(2*self borderWidth)). 
   self addMorph: toolbar . 
   cells:=Matrix new: n tabulate: [:i :j | self newCellAt: i at: j ]. ! !

!LOGame methodsFor: 'event handling' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:38'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'RoxanaLimachi 9/27/2012 14:02'!
newCellAt: i at: j
   "Create a cell for position (i,j) and add it to my on - screen
     representation at the appropriate screen position. Answer the new cell"
   | c origin toolbar| 
   c := LOCell new.
  toolbar := LOToolbar new.
   origin := self innerBounds origin .
   self addMorph: c.
   c position: ((i-1)*c width)@((j-1)*c height + toolbar height )+origin.
   c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
    ^c! !

!LOGame methodsFor: 'game logic' stamp: 'NuryYulenyArosquipaYanque 9/20/2012 13:11'!
toggleNeighboursOfCellAt: i at: j
   (i>1) ifTrue: [(cells at: i-1 at:j) toggleState].
   (i<self cellsPerSide) ifTrue: [(cells at: i+1 at:j) toggleState].
   (j>1) ifTrue: [(cells at: i at:j-1) toggleState].
   (i<self cellsPerSide) ifTrue: [(cells at: i at:j+1) toggleState].! !
